{-# LANGUAGE DeriveGeneric #-}
module Main where

import GHC.Generics
import Data.Aeson
import Data.Aeson.Types

import System.Environment
import qualified Data.ByteString.Lazy as BS
import System.IO 
import Datatypes
import Opt
import JSONDeser
import VM (Command, cmdToString)


data JSONSer = JSONSer { problemId :: Int,
                         seed :: Int,
                         tag :: String,
                         solution :: String
                       } deriving (Show, Generic)

instance FromJSON JSONSer
instance ToJSON JSONSer

main :: IO ()
main = do args <- getArgs
          opt <- parseArgs args
          file <- return ((optFile opt) !! 0)
          str <- BS.readFile file
          
packAll :: Int -> [Int] -> [[Command]] -> [JSONSer] 
packAll id seeds commandLists = zipWith (\x y -> JSONSer id x "lilik0" y) seeds commandStrings
  where
    commandStrings = map cmdToString commandLists


